<template>
  <div class="wp-12 wp-layout wp-layout--no-pad wp-layout--form">
    <wp-input class="wp-12" type="autocomplete" v-model="role.id"
      label="Роль" placeholder="Начните ввод для поиска" :items="autocompleteData"/>
    <div class="wp-12 wp-layout wp-layout--no-pad">
      <button class="wp-button wp-button--margin-right" @click="submit">
        Сохранить изменения
      </button>
      <button class="wp-button wp-button--cancel" @click="$emit('close')">
        Отменить
      </button>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex';

import WpInput from '@/components/WpInput.vue';

export default {
  name: 'UserRole',
  components: {
    WpInput,
  },
  data() {
    return {
      role: {
        id: undefined,
        display: false,
      },
    };
  },
  props: {
    user: {
      type: Object,
      required: true,
    },
    data: {
      type: Object,
      default: () => undefined,
    },
  },
  computed: {
    ...mapState('session', ['selectedOrganization']),
    ...mapState('organization', ['roles']),
    autocompleteData() {
      return this.roles.map(item => ({
        text: item.name,
        prop: item.id,
      }));
    },
    isEditing() {
      return !!this.$props.data;
    },
  },
  methods: {
    ...mapActions('organization', ['setRole']),
    submit() {
      this.addRoleToUser();
    },
    async addRoleToUser() {
      try {
        this.role.user_id = this.$props.user.id;
        await this.setRole(this.role);
        this.$toasted.success('Роль прикреплена');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
  },
  created() {
    if (this.$props.data) {
      this.role = Object.assign({}, this.$props.data);
    }
  },
};
</script>

<style></style>
